/************************************************************************************
*  Copyright (c), 2019, HelTec Automatic(TM) Technology co.,LTD.
*            All rights reserved.
*
* Http:    www.heltec.cn
* Email:   suppor@heltec.cn
* WebShop: heltec.taobao.com
*
* File name: main.c
* Processor: STM32F103VBT6
* Compiler : MDK fo ARM 5.26
* 
* Author : Aaron.Lee
* Version: 1.00
* Date   : 2019.3.4
* Email  : suppor@heltec.cn
* Modification: none
* 
* Description: Heltec 2.13" 212*104 Black-White E-Ink driver code
*
* Others: none;
*
* Function List:
*	1. void EPD_W21_WriteCMD(uint8_t command); 			// Write Command via hardware SPI bus;
* 2. void EPD_W21_WriteDATA(uint8_t command); 		// Display the number;
* 3. void Display_Num(void);                      // Write a picture data to display buffer;
* 4. void DisplayRefresh(void); 									// Refresh display, must run this function after WriteBuffer;
* 5. void CheckStatus(void);											// Check busy;
* 6. void Display_Init(void);											// Initial display.
* 7. void pic_display_white(void);                // Display white
*
* History: none;
*
*************************************************************************************/

#include "e_ink_213_BW.h"

#include "stm32f1xx.h"

extern SPI_HandleTypeDef hspi1;

unsigned int size;
unsigned char HRES,VRES_byte1,VRES_byte2;

 void EPD_W21_WriteCMD(uint8_t command)
{

  HAL_GPIO_WritePin(GPIOD, CS, GPIO_PIN_RESET);                  
	HAL_GPIO_WritePin(GPIOE, DC, GPIO_PIN_RESET);		// command write
	HAL_SPI_Transmit(&hspi1,&command,sizeof(command),100);
	HAL_GPIO_WritePin(GPIOD, CS, GPIO_PIN_SET);
}
	
 void EPD_W21_WriteDATA(uint8_t command)
{

  HAL_GPIO_WritePin(GPIOD, CS, GPIO_PIN_RESET);                  
	HAL_GPIO_WritePin(GPIOE, DC, GPIO_PIN_SET);			// command write
	HAL_SPI_Transmit(&hspi1,&command,sizeof(command),100);
	HAL_GPIO_WritePin(GPIOD, CS, GPIO_PIN_SET);
}



void EPD_W21_Init(void)
{		
	  HAL_GPIO_WritePin(GPIOE, BS, GPIO_PIN_RESET); // command write
		HAL_GPIO_WritePin(GPIOE, RST, GPIO_PIN_RESET); // command write
  	HAL_Delay(100);
		HAL_GPIO_WritePin(GPIOE, RST, GPIO_PIN_SET); // command write
	  HAL_Delay(100); 
    //EPD_W21_DispInit();		// pannel configure
}

void pic_display_white(void)
{
	unsigned int i;
		EPD_W21_WriteCMD(0x10);
		for(i=0;i<5624;i++)	     
		{
				EPD_W21_WriteDATA(0x00);  
		}  
		HAL_Delay(2);

		EPD_W21_WriteCMD(0x13);
		for(i=0;i<5624;i++)	     
		{
				EPD_W21_WriteDATA(0xff);  
		}  
		HAL_Delay(2);	
}

void Display_Num(void)
{
	partial_display(0,32,0,64, partial00, partial01); //partial display 0 1                
	partial_display(0,32,0,64, partial01, partial02); //partial display 1 2
	partial_display(0,32,0,64, partial02, partial03); //partial display 2 3                       
	partial_display(0,32,0,64, partial03, partial04); //partial display 3 4                                  
	partial_display(0,32,0,64, partial04, partial05); //partial display 4 5                   
	partial_display(0,32,0,64, partial05, partial06); //partial display 5 6                  
	partial_display(0,32,0,64, partial06, partial07); //partial display 6 7
	partial_display(0,32,0,64, partial07, partial08); //partial display 7 8
	partial_display(0,32,0,64, partial08, partial09); //partial display 8 9
}
void pic_display1(void)
{
	unsigned int i;
		EPD_W21_WriteCMD(0x10);
		for(i=0;i<5624;i++)	     
		{
				EPD_W21_WriteDATA(0x00);  
		}  
		HAL_Delay(2);

		EPD_W21_WriteCMD(0x13);
		for(i=0;i<5624;i++)	     
		{
				EPD_W21_WriteDATA(gImage_1[i]);  
		}  
		HAL_Delay(2);	 	 
}

void pic_display2(void)
{
	unsigned int i;
	EPD_W21_WriteCMD(0x10);
	for(i=0;i<5624;i++)	     
	{
		EPD_W21_WriteDATA(0x00);  
	}  

	EPD_W21_WriteCMD(0x13);	  	
	for(i=0;i<5624;i++)	     
	{
   EPD_W21_WriteDATA(gImage_2[i]);  

	}  
}


/***************** partial full screen display picture*************************/
void partial_full00(void)
{
	unsigned int i;
	for(i=0;i<2756;i++)	     
	{
			EPD_W21_WriteDATA(0x00);  
	}  
}
void partial_full01(void)
{
	unsigned int i;
	for(i=0;i<2756;i++)	     
	{
			EPD_W21_WriteDATA(~gImage_1[i]);  
	}  
}
void partial_full02(void)
{
	unsigned int i;
	for(i=0;i<2756;i++)	     
	{
			EPD_W21_WriteDATA(~gImage_2[i]);  
	}  
}

/***************** partial display 0~9 picture*************************/
void partial00(void)
{
	unsigned int i;
	for(i=0;i<256;i++)	     
	{
			EPD_W21_WriteDATA(0x00);  
	}  
}

void partial01(void)
{
	unsigned int i;

		for(i=0;i<256;i++)	     
			{
			EPD_W21_WriteDATA (~gImage_num1[i]);
			HAL_Delay(2);  
			}	
	}
void partial02(void)
{
  unsigned int i;
		for(i=0;i<256;i++)	     
			{
			EPD_W21_WriteDATA (~gImage_num2[i]);
			HAL_Delay(2);  
			}	
	}
void partial03(void)
{
	  unsigned int i;
		for(i=0;i<256;i++)	     
			{
			EPD_W21_WriteDATA (~gImage_num3[i]);
			HAL_Delay(2);  
			}	
	}
void partial04(void)
{
	  unsigned int i;
		for(i=0;i<256;i++)	     
			{
			EPD_W21_WriteDATA (~gImage_num4[i]);
			HAL_Delay(2);  
			}	
	}
void partial05(void)
{
	  unsigned int i;
		for(i=0;i<256;i++)	     
			{
			EPD_W21_WriteDATA (~gImage_num5[i]);
			HAL_Delay(2);  
			}	
	}
void partial06(void)
{
	  unsigned int i;
		for(i=0;i<256;i++)	     
			{
			EPD_W21_WriteDATA (~gImage_num6[i]);
			HAL_Delay(2);  
			}	
	}
void partial07(void)
{
	  unsigned int i;
		for(i=0;i<256;i++)	     
			{
			EPD_W21_WriteDATA (~gImage_num7[i]);
			HAL_Delay(2);  
			}	
	}
void partial08(void)
{
	  unsigned int i;
		for(i=0;i<256;i++)	     
			{
			EPD_W21_WriteDATA (~gImage_num8[i]);
			HAL_Delay(2);  
			}	
	}
void partial09(void)
{
	  unsigned int i;
		for(i=0;i<256;i++)	     
			{
			EPD_W21_WriteDATA (~gImage_num9[i]);
			HAL_Delay(2);  
			}	
	}
/*************************EPD display init function******************************************************/
void EPD_display_init(void)
{
	  HRES=0x68;						//104
	  VRES_byte1=0x00;			//212
	  VRES_byte2=0xd4;
	  EPD_W21_Init();
		EPD_W21_WriteCMD(0x01);			//POWER SETTING 
		EPD_W21_WriteDATA (0x03);	          
		EPD_W21_WriteDATA (0x00);
		EPD_W21_WriteDATA (0x2b);
		EPD_W21_WriteDATA (0x2b);
		EPD_W21_WriteDATA (0x03);

		EPD_W21_WriteCMD(0x06);         //boost soft start
		EPD_W21_WriteDATA (0x17);		//A
		EPD_W21_WriteDATA (0x17);		//B
		EPD_W21_WriteDATA (0x17);		//C       

		EPD_W21_WriteCMD(0x04);  
		CheckStatus();

		EPD_W21_WriteCMD(0x00);			//panel setting
		EPD_W21_WriteDATA(0xbf);		//LUT from OTP128x296
		EPD_W21_WriteDATA(0x0d);		//VCOM to 0V fast
		
		EPD_W21_WriteCMD(0x30);			//PLL setting
    EPD_W21_WriteDATA (0x3a);   // 3a 100HZ   29 150Hz 39 200HZ	31 171HZ

		EPD_W21_WriteCMD(0x61);			//resolution setting
		EPD_W21_WriteDATA (HRES);        	 
		EPD_W21_WriteDATA (VRES_byte1);		
		EPD_W21_WriteDATA (VRES_byte2);
		
		EPD_W21_WriteCMD(0x82);			//vcom_DC setting  	
    EPD_W21_WriteDATA (0x28);	

		EPD_W21_WriteCMD(0X50);			//VCOM AND DATA INTERVAL SETTING			
		EPD_W21_WriteDATA(0x97);		//WBmode:VBDF 17|D7 VBDW 97 VBDB 57		WBRmode:VBDF F7 VBDW 77 VBDB 37  VBDR B7
	}
/***************************full display function*************************************/
void full_display(void pic_display(void))
{

		
		pic_display(); //picture
		lut(); //Power settings
		EPD_W21_WriteCMD(0x12);			//DISPLAY REFRESH 	
		HAL_Delay(100);	    //!!!The delay here is necessary, 200uS at least!!!     
		CheckStatus();
}

/***************************partial display function*************************************/

void partial_display(uint16_t x_start,uint16_t x_end,uint16_t y_start,uint16_t y_end ,void partial_old(void),void partial_new(void)) //partial display
{
	  EPD_W21_WriteCMD(0x82);			//vcom_DC setting  	
    EPD_W21_WriteDATA (0x08);	
		EPD_W21_WriteCMD(0X50);
		EPD_W21_WriteDATA(0x47);		
		lut1();
	  EPD_W21_WriteCMD(0x91);		//This command makes the display enter partial mode
		EPD_W21_WriteCMD(0x90);		//resolution setting
		EPD_W21_WriteDATA (x_start);   //x-start     
		EPD_W21_WriteDATA (x_end-1);	 //x-end	

		EPD_W21_WriteDATA (y_start/256);
		EPD_W21_WriteDATA (y_start%256);   //y-start    
		
		EPD_W21_WriteDATA (y_end/256);		
		EPD_W21_WriteDATA (y_end%256-1);  //y-end
		EPD_W21_WriteDATA (0x28);	

		EPD_W21_WriteCMD(0x10);	       //writes Old data to SRAM for programming
		partial_old();
		EPD_W21_WriteCMD(0x13);				 //writes New data to SRAM.
		partial_new();
    	
		EPD_W21_WriteCMD(0x12);		 //DISPLAY REFRESH 		             
		HAL_Delay(3);     //!!!The delay here is necessary, 200uS at least!!!     
		CheckStatus();
	  
}
/////////////////////////////Enter deep sleep mode////////////////////////
void deep_sleep(void) //Enter deep sleep mode
{
		EPD_W21_WriteCMD(0X50);
		EPD_W21_WriteDATA(0xf7);	
		EPD_W21_WriteCMD(0X02);  	//power off
		EPD_W21_WriteCMD(0X07);  	//deep sleep
		EPD_W21_WriteDATA(0xA5);
}

//LUT download
void lut(void)
{
	unsigned int count;
	EPD_W21_WriteCMD(0x20);
	for(count=0;count<44;count++)	     
		{EPD_W21_WriteDATA(lut_vcomDC[count]);}

	EPD_W21_WriteCMD(0x21);
	for(count=0;count<42;count++)	     
		{EPD_W21_WriteDATA(lut_ww[count]);}   
	
	EPD_W21_WriteCMD(0x22);
	for(count=0;count<42;count++)	     
		{EPD_W21_WriteDATA(lut_bw[count]);} 

	EPD_W21_WriteCMD(0x23);
	for(count=0;count<42;count++)	     
		{EPD_W21_WriteDATA(lut_wb[count]);} 

	EPD_W21_WriteCMD(0x24);
	for(count=0;count<42;count++)	     
		{EPD_W21_WriteDATA(lut_bb[count]);} 
}

void lut1(void)
{
	unsigned int count;
	EPD_W21_WriteCMD(0x20);
	for(count=0;count<44;count++)	     
		{EPD_W21_WriteDATA(lut_vcom1[count]);}

	EPD_W21_WriteCMD(0x21);
	for(count=0;count<42;count++)	     
		{EPD_W21_WriteDATA(lut_ww1[count]);}   
	
	EPD_W21_WriteCMD(0x22);
	for(count=0;count<42;count++)	     
		{EPD_W21_WriteDATA(lut_bw1[count]);} 

	EPD_W21_WriteCMD(0x23);
	for(count=0;count<42;count++)	     
		{EPD_W21_WriteDATA(lut_wb1[count]);} 

	EPD_W21_WriteCMD(0x24);
	for(count=0;count<42;count++)	     
		{EPD_W21_WriteDATA(lut_bb1[count]);}   
}

//Detection busy
void CheckStatus(void)
{
	unsigned char busy;
	do
	{
		EPD_W21_WriteCMD(0x71);
		busy = HAL_GPIO_ReadPin(GPIOE, BUSY);
		busy =!(busy & 0x01);        
	}
	while(busy);   
	HAL_Delay(200);                       
}
/***********************************************************
						end file
***********************************************************/

